freeslot("sfx_sysmsg")

local hostmod_sysmsg = CV_RegisterVar({
	name = "hm_autoshout",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hostmod_sysmsgname = CV_RegisterVar({
	name = "hm_shout_name",
	defaultvalue = "Cute Robot Girl",
	flags = CV_NETVAR,
	possiblevalue = nil
})
local hostmod_sysmsgcolor = CV_RegisterVar({
	name = "hm_shout_color",
	defaultvalue = "Pink",
	flags = CV_NETVAR,
	possiblevalue = SG_CVSkinColors
})

local colorstr = hm_shared.colorstr

local function dosay(p, msg)
    -- Function may fail if user types something wrong, like "\notanumber", so
    -- if that happens, notify user about it and just print unformatted message
    local msg_colored

    local ok, msg_colored = pcall(colorstr, msg)

    if not ok then
        CONS_Printf(p, "Failed to parse message. Sending it unparsed anyway")
        msg_colored = msg
    end

	chatprint(msg_colored)
	//S_StartSound(nil, sfx_sysmsg)
end

local function hmsay(p, ...)
	if not ... then
		CONS_Printf(p, "What are you even trying to do?")
		return
	end
	local msg = table.concat({...}, " ")
	dosay(p, msg)
end
COM_AddCommand("shout", hmsay, 1)

addHook("PlayerMsg", function(source, msgtype, target, msg)
	if msgtype != 0 then return end
	if not (server == source or IsPlayerAdmin(source)) then return end
	if not hostmod_sysmsg.value then return end
	dosay(source, msg)
	return true
end)
