local hostmod_powerupsound = CV_RegisterVar({
	name = "powersound",
	defaultvalue = "Off",
	flags = 0,
	possiblevalue = CV_OnOff
})
local hostmod_powerupflash = CV_RegisterVar({
	name = "powerflash",
	defaultvalue = "Off",
	flags = 0,
	possiblevalue = CV_OnOff
})

addHook("ThinkFrame", function()
	for p in players.iterate
		local v = p.kartstuff[k_growshrinktimer]
		if v > 0 and v <= 3*TICRATE
			local r = v / TICRATE + 1
			local d = r*2 + 1
			if hostmod_powerupflash.value then
				if (leveltime % d < r) and hostmod_powerupflash.value
					p.mo.color = SKINCOLOR_PERIWINKLE
					p.mo.colorized = true
				else
					p.mo.color = p.skincolor
					p.mo.colorized = false
				end
			end
			if not (v % TICRATE) and hostmod_powerupsound.value then
				S_StartSound(nil, sfx_s242, p)
			end
		end
		
		local it = p.kartstuff[k_invincibilitytimer]
		if it > 0 and it <= 3*TICRATE then
			-- TODO: Alternate visual for invincibility timer?
			-- It's really really fucking busy, so this is hard...
			if hostmod_powerupsound.value and not (it % TICRATE) then
				S_StartSound(nil, sfx_s242, p)
			end
		end
	end
end)