rawset(_G, "hm_debug", CV_RegisterVar({
	name = "hm_debug",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
}))

hud.add(function(v)
	if not hm_debug.value then return end
	v.drawFill(0, 0, v.width(), 6*v.dupy(), 255|V_NOSCALESTART)
	v.drawString(1, 1, "HOSTMOD v"..HOSTMOD.." - DEBUG MODE. DO NOT USE IN PRODUCTION I SWEAR TO GOD.", V_SNAPTOTOP, "small")
end)

rawset(_G, "hm_dprint", function(...)
	if not hm_debug.value then return end
	local fug = "\132[HM]\128 "
	if leveltime then fug = $ + "\132(" + leveltime + ")\128 " end
	if not ... then
		fug = $ + "Did you seriously pass NOTHING to a debug print?"
	else
		fug = $ + table.concat({...}, " ")
	end
	CONS_Printf(server, fug)
end)
